function effect_load()
	bars = {}
	for i=#bars, 1, -1 do
		table.remove(bars,i)
	end
	for i=0,screenH/10 do
		b = {}
		b.y = i * 10
		table.insert(bars,b)
	end
end


ripples = {}
eripples = {}
barSpeed = 50
rtimer = 0
function effect_update(dt)
	for i,v in ipairs(bars) do
		v.y = v.y + barSpeed * dt
		if(v.y >= screenH + 10) then
			v.y = 0
		end
	end
	for i,v in ipairs(ripples) do
		v.r = v.r + (v.r * 5) * dt
		if(v.r >= 100) then
			table.remove(ripples,i)
		end
	end
	for i,v in ipairs(eripples) do
		v.r = v.r + (v.r * 5) * dt
		if(v.r >= 100) then
			table.remove(eripples,i)
		end
	end
	
	if(gamestate == "gameover") then
		rtimer = rtimer - 1 * dt
		if(rtimer <= 0) then
			r = {}
			r.r = 1
			table.insert(ripples,r)
			r = {}
			r.r = 0.4
			table.insert(ripples,r)			
			rtimer = 0.5
		end
	end
end

function effect_draw()
	if(effect == true) then
	love.graphics.setColor(0,200,100,30)
	for i,v in ipairs(bars) do
		if i % 2 == 1 then
		love.graphics.rectangle("fill",0,v.y - 10,screenW,10)
		end
	end
	love.graphics.setColor(200,100,0,30)
	for i,v in ipairs(bars) do
		if not(i % 2 == 1) then
		love.graphics.rectangle("fill",0,v.y - 10,screenW,10)
		end
	end
	end
	
	love.graphics.setColor(0,0,200)
	for i,v in ipairs(ripples) do
		love.graphics.circle("line",player.x * tileSize + cam.x + 5, player.y * tileSize + cam.y + 5, v.r)
		love.graphics.circle("line",player.x * tileSize + cam.x + 5, player.y * tileSize + cam.y + 5, v.r - 1)
	end
	
	love.graphics.setColor(255,255,255)
	
	love.graphics.setColor(255,0,0)
	for i,v in ipairs(eripples) do
		love.graphics.circle("line",v.x * tileSize + cam.x + 5, v.y * tileSize + cam.y + 5, v.r)
		love.graphics.circle("line",v.x * tileSize + cam.x + 5, v.y * tileSize + cam.y + 5, v.r - 1)
	end
	
	love.graphics.setColor(255,255,255)
end

function effect_draw2()
	if(effect == true) then
	love.graphics.setColor(0,200,100,50)
	for i,v in ipairs(bars) do
		if i % 2 == 1 then
		love.graphics.rectangle("fill",0,v.y - 10,screenW,10)
		end
	end
	love.graphics.setColor(200,100,0,50)
	for i,v in ipairs(bars) do
		if not(i % 2 == 1) then
		love.graphics.rectangle("fill",0,v.y - 10,screenW,10)
		end
	end
	end
	love.graphics.setColor(255,255,255)
end