
player = {}
player.pic = love.graphics.newImage("player.png")
player.x = 32
player.y = 24
player.tileX = 0
player.tileY = 0
player.speed = 20
player.r = 0
player.time = 10.0
player.distime = 10
player.spread = 0 -- bullet spread
player.potions = 0
player.blind = false
player.btimer = 5
player.lastd = 0

rightCol = false
leftCol = false
topCol = false
downCol = false

shadows = {}
sTimer = 0.5

bullets = {}

hit = love.audio.newSource("hit.ogg")
shoot = love.audio.newSource("shoot.ogg")
powerup = love.audio.newSource("powerup.ogg")
blip = love.audio.newSource("blip.ogg")
expl = love.audio.newSource("exp.ogg")

mx = 0
my = 0

ddistime = 0
checkdistime = 0

function player_update(dt)
	player.tileX = math.floor(player.x)
	player.tileY = math.floor(player.y)
	player.tileLX = math.floor(player.x - 0.1)
	player.tileLY = math.floor(player.y - 0.1)
	
	if(locked == false) then
		if(player.tileX == mapW and player.lastd ~= 4) then
			--map = blank
			player.x = 3
			ranGen()
			player.lastd = 1

		end
		if(player.tileX == 2 and player.lastd ~= 1) then
			--map = blank
			
			player.lastd = 4
			player.x = mapW - 3
			ranGen()
		end
		if(player.tileY == 2 and player.lastd ~= 3) then
			--map = blank
			
			player.lastd = 2
			player.y = mapH - 3
			ranGen()
		end
		if(player.tileY == mapH + 1 and player.lastd ~= 2) then
			--map = blank
			
			player.lastd = 3
			player.y = 3
			ranGen()
		end

	end
	--collision
	rightCol = false
	leftCol = false
	topCol = false
	downCol = false
	--right
	if(map[player.tileY][player.tileX + 1] == 1) then
		rightCol = true
	end
	--left
	if(map[player.tileY][player.tileLX] == 1) then
		leftCol = true
	end
	--up
	if(map[player.tileLY][player.tileX] == 1) then
		topCol = true
	end
	--down
	if(map[player.tileY + 1][player.tileX] == 1) then
		downCol = true
	end
	
	
	--movement
	if(love.keyboard.isDown("d") and rightCol == false) then
		player.x = player.x + player.speed * dt
	end
	if(love.keyboard.isDown("a") and leftCol == false) then
		player.x = player.x - player.speed * dt
	end
	if(love.keyboard.isDown("w") and topCol == false) then
		player.y = player.y - player.speed * dt
	end
	if(love.keyboard.isDown("s") and downCol == false) then
		player.y = player.y + player.speed * dt
	end
	
	mx = love.mouse.getX() * sx
	my = love.mouse.getY() * sy
	player.r = math.atan2((my - player.y * tileSize),(mx - player.x * tileSize))
	
	--bullets
	for i,v in ipairs(bullets) do
		v.x = v.x + v.dx * dt
		v.y = v.y + v.dy * dt
		
		tX = math.floor(v.x/tileSize)
		tY = math.floor(v.y/tileSize)
		if(tX < 2 or tX > mapW - 1 or tY < 2 or tY > mapH - 1) then
		table.remove(bullets,i)
		
		elseif(map[tY][tX] == 1) then
			table.remove(bullets,i)
		end

	end
	for i,v in ipairs(eBullets) do
		if CheckCollision(player.x * tileSize,player.y * tileSize,10,10,v.x * tileSize,v.y * tileSize,10,10) then
			player.time = player.time - 1
			cam.x = cam.x + math.random(-50,50)
			cam.y = cam.y + math.random(-50,50)
			table.remove(eBullets,i)
			love.audio.play(hit)
		end
	end
	
	tX = 10
	tY = 10
	--blindness
	if(player.blind == true) then
		player.btimer = player.btimer - 1 * dt
		if(player.btimer <= 0) then
			player.blind = false
			player.btimer = 5
		end
	end
	--Shadow/blur
	sTimer = sTimer - 1 * dt
	if(sTimer <= 0) then
		s = {}
		s.x = player.x
		s.y = player.y
		s.timer = 0.3
		table.insert(shadows,s)
		
		sTimer = 0.03
	end
	
	for i,v in ipairs(shadows) do
		v.timer = v.timer + 1 * dt
		if(v.timer >= 0.5) then
			table.remove(shadows,i)
		end
	end
	--timer
	if(boss == false) then
		player.time = player.time - 1 * dt
	end
	if(player.time > 10) then
		player.time = 10
	end
	if(player.time <= 0) then
		love.audio.play(expl)
		gamestate = "gameover"
	end
	player.distime = math.floor(player.time * 100)
	player.distime = player.distime / 100
	if(player.distime <= 3) then
		tim = tim - 1 * dt
		if( tim <= 0) then
			love.audio.play(blip)
			tim = 0.4
		end
	end

end
tim = 0
bulletSpeed = 300

function love.mousepressed(x,y,button)
	if(button == "l") then
		cam.x = cam.x + math.random(-10,10)
		cam.y = cam.y + math.random(-10,10)
		love.audio.play(shoot)
		if(player.spread == 0) then
				bullet = {}
				bullet.x = player.x * tileSize + 5
				bullet.y = player.y * tileSize + 5
				bullet.tx = x/sy - cam.x
				bullet.ty = y/sy - cam.y
				bullet.angle = math.atan2((bullet.ty - bullet.y),(bullet.tx - bullet.x))
				bullet.dx = math.cos(bullet.angle) * bulletSpeed
				bullet.dy = math.sin(bullet.angle) * bulletSpeed
				
				table.insert(bullets,bullet)		
		else
		for i = -player.spread/2,player.spread/2 do
			if not(i == 0) then
				bullet = {}
				bullet.x = player.x * tileSize + 5
				bullet.y = player.y * tileSize + 5
				bullet.tx = x/sx - cam.x
				bullet.ty = y/sy - cam.y
				bullet.angle = math.atan2((bullet.ty - bullet.y),(bullet.tx - bullet.x))
				bullet.dx = math.cos(bullet.angle +(0.2 * i)) * bulletSpeed
				bullet.dy = math.sin(bullet.angle + (0.2 * i)) * bulletSpeed
				
				table.insert(bullets,bullet)
			end
		end
		end
	end
end

function drinkpotion()
	
	r = math.random(1,20)
	if(r >= 5) then
		r = math.random(1,10)
		if(r >= 5) then
			player.speed = player.speed + 1
			if(player.speed >= 50) then
				player.speed = 50
			end
			r = {}
			r.r = 1
			table.insert(ripples,r)
			r = {}
			r.r = 0.4
			table.insert(ripples,r)
			
			
		else
			player.time = 10
		end
		love.audio.play(powerup)
	else
		r = math.random(1,10)
		if( r>= 5) then
			player.blind = true
		else
			player.time = player.time - 2
		end
		love.audio.play(hit)
	end
end

function player_draw()
	love.graphics.setColor(200,200,200,50)
	love.graphics.setFont(large)
	love.graphics.print(player.distime,10 * tileSize + cam.x,12 * tileSize + cam.y)
	love.graphics.setColor(255,255,255)
	love.graphics.setFont(normal)
	--love.graphics.rectangle("fill",player.x * tileSize + cam.x, player.y * tileSize + cam.y,10,10)
	
	for i,v in ipairs(shadows) do
		love.graphics.setColor(0,100,200,255/((v.timer + 1) * 2))
		love.graphics.rectangle("fill",v.x * tileSize + cam.x, v.y * tileSize + cam.y,10,10)
	end
	love.graphics.setColor(255,255,255)
	love.graphics.draw(player.pic,player.x * tileSize + cam.x + 5, player.y * tileSize + cam.y + 5,player.r,1,1,5,5)

	
	love.graphics.setColor(0,0,255)
	for i,v in ipairs(bullets) do
		love.graphics.circle("fill",v.x + cam.x,v.y + cam.y,3)
	end
	love.graphics.setColor(255,255,255)

end